Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/carb_chem.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/carb_chem.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/carb_chem.F90	(revision 10302)
@@ -40,6 +40,8 @@
 # endif
                                    zalk, zdic, zsal, zsil, ztmp 
-      USE dom_oce,           ONLY: gdept_0, gdept_n, gdepw_0, gdepw_n,    &
-                                   gphit, mbathy, tmask
+      USE dom_oce,           ONLY: gdept_0, gdepw_0, gphit, mbathy, tmask
+# if defined key_vvl
+      USE dom_oce,           ONLY: gdept_n, gdepw_n
+# endif
       USE in_out_manager,    ONLY: lwp, numout
       USE oce,               ONLY: PCO2a_in_cpl, tsb, tsn
@@ -103,8 +105,4 @@
                !! OPEN wet point IF..THEN loop
                IF (tmask(ji,jj,jk).eq.1) THEN
-                  IF (lk_oasis) THEN
-                     !! use 2D atm xCO2 from atm coupling
-                     f_xco2a(ji,jj) = PCO2a_in_cpl(ji,jj)
-                  ENDIF
                   !! Do carbonate chemistry
                   !!
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus.F90	(revision 10302)
@@ -6,4 +6,5 @@
    !! History :
    !!   -   ! 2017-04 (M. Stringer)        Code taken from trcbio_medusa.F90
+   !!   -   ! 2017-08 (A. Yool)            Revise slow-sinking of detritus
    !!----------------------------------------------------------------------
 #if defined key_medusa
@@ -35,14 +36,24 @@
                                         f_sbenin_n, fdd,                   &
                                         idf, idfval,                       &   
-# if defined key_roam
+                                        fslowsink,                         &
+                                        fslowgain, fslowloss,              &
+# if defined key_roam
+                                        fslowsinkc,                        &
+                                        fslowgainc, fslowlossc,            &
                                         fddc,                              &
 # endif
                                         fun_T, fun_Q10, zdet, zdtc
       USE detritus_fast_sink_mod, ONLY: detritus_fast_sink
-      USE dom_oce,                ONLY: mbathy, tmask
+      USE dom_oce,                ONLY: mbathy, e3t_0, gphit, tmask
+# if defined key_vvl
+      USE dom_oce,                ONLY: e3t_n
+# endif
       USE in_out_manager,         ONLY: lwp, numout
       USE par_oce,                ONLY: jpim1, jpjm1
       USE sms_medusa,             ONLY: jmd, jorgben, jsfd, vsed,          &
                                         xrfn, xmd, xmdc, xthetad
+
+   !!* Substitution
+#  include "domzgr_substitute.h90"
 
       !! Level
@@ -123,4 +134,39 @@
          DO ji = 2,jpim1
             if (tmask(ji,jj,jk) == 1) then
+               !!----------------------------------------------------------------------
+               !! Detritus sinking (AXY, 08/08/18)
+	       !! Replaces slow-sinking done in trcsed_medusa.F90
+               !!
+               !! Uses the fslowsink variable to carry slow-sinking detritus from one
+               !! grid level to the next, variable fslowgain to "add" detritus sinking
+               !! from above and variable fslowloss to "subtract" detritus sinking out
+               !! to below; these variables appear in the differential equations of
+               !! detrital nitrogen and carbon below
+               !!----------------------------------------------------------------------
+               !!
+               fslowgain(ji,jj)  = fslowsink(ji,jj) / fse3t(ji,jj,jk)                  ! = mmol N / m3 / d
+               if (jk.lt.mbathy(ji,jj)) then
+                  fslowloss(ji,jj)  = (zdet(ji,jj) * vsed * 86400.) / fse3t(ji,jj,jk)  ! = mmol N / m3 / d
+               else
+                  fslowloss(ji,jj)  = 0.                                               ! = mmol N / m3 / d
+               endif
+               fslowsink(ji,jj) = fslowloss(ji,jj) * fse3t(ji,jj,jk)                   ! = mmol N / m2 / d
+               !!
+#  if defined key_roam
+               fslowgainc(ji,jj) = fslowsinkc(ji,jj) / fse3t(ji,jj,jk)                 ! = mmol C / m3 / d
+               if (jk.lt.mbathy(ji,jj)) then
+                  fslowlossc(ji,jj) = (zdtc(ji,jj) * vsed * 86400.) / fse3t(ji,jj,jk)  ! = mmol C / m3 / d
+               else
+                  fslowlossc(ji,jj) = 0.                                               ! = mmol C / m3 / d
+               endif
+               fslowsinkc(ji,jj) = fslowlossc(ji,jj) * fse3t(ji,jj,jk)                 ! = mmol C / m2 / d
+#  endif
+            ENDIF
+         ENDDO
+      ENDDO
+
+      DO jj = 2,jpjm1
+         DO ji = 2,jpim1
+            if (tmask(ji,jj,jk) == 1) then
                !!---------------------------------------------------------
                !! Detritus addition to benthos
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus_fast_sink.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus_fast_sink.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus_fast_sink.F90	(revision 10302)
@@ -66,6 +66,8 @@
                                    idf, idfval,                            &
                                    zdet, zdtc
-      USE dom_oce,           ONLY: e3t_0, e3t_n, gdepw_0, gdepw_n,         &
-                                   gphit, mbathy, tmask
+      USE dom_oce,           ONLY: e3t_0, gdepw_0, gphit, mbathy, tmask
+# if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n, gdepw_n
+# endif
       USE in_out_manager,    ONLY: lwp, numout
       USE oce,               ONLY: tsn
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/iron_chem_scav.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/iron_chem_scav.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/iron_chem_scav.F90	(revision 10302)
@@ -35,6 +35,8 @@
                                    zdet, zfer, zphd, zphn, zzme, zzmi,    &
                                    idf, idfval                          
-      USE dom_oce,           ONLY: e3t_0, e3t_n, gdepw_0, gdepw_n,        &
-                                   mbathy, tmask
+      USE dom_oce,           ONLY: e3t_0, gdepw_0, mbathy, tmask
+#if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n, gdepw_n
+#endif
       USE par_kind,          ONLY: wp
       USE in_out_manager,    ONLY: lwp, numout
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/phytoplankton.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/phytoplankton.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/phytoplankton.F90	(revision 10302)
@@ -6,4 +6,5 @@
    !! History :
    !!   -   ! 2017-04 (M. Stringer)        Code taken from trcbio_medusa.F90
+   !!   -   ! 2017-08 (A. Yool)            Mean mixed layer chlorophyll
    !!----------------------------------------------------------------------
 #if defined key_medusa
@@ -42,6 +43,9 @@
                                    zchd, zchn, zdet, zdin, zdtc,         &
                                    zfer, zpds, zphd, zphn, zsil,         &
-                                   zzme, zzmi
-      USE dom_oce,           ONLY: e3t_0, e3t_n, gdepw_0, gdepw_n, tmask
+                                   zzme, zzmi, fchl_ml
+      USE dom_oce,           ONLY: e3t_0, gdepw_0, tmask
+#if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n, gdepw_n
+#endif
       USE in_out_manager,    ONLY: lwp, numout
       USE oce,               ONLY: tsn
@@ -55,4 +59,5 @@
                                    xvpd, xvpn, xxi
       USE zdfmxl,            ONLY: hmld
+      USE lbclnk,            ONLY: lbc_lnk
 
    !!* Substitution
@@ -373,7 +378,11 @@
                fprd_ml(ji,jj) = fprd_ml(ji,jj) + (fprd(ji,jj) * zphd(ji,jj) * &
                                                   fse3t(ji,jj,jk) * fq0)
-            ENDIF
-         ENDDO
-      ENDDO
+	       !! AXY (16/08/17)
+	       fchl_ml(ji,jj) = fchl_ml(ji,jj) + ((zchn(ji,jj) + zchd(ji,jj)) * &
+	                                          (fse3t(ji,jj,jk) * fq0) / hmld(ji,jj))
+            ENDIF
+         ENDDO
+      ENDDO
+      CALL lbc_lnk(fchl_ml(:,:),'T',1. )
 
       DO jj = 2,jpjm1
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/plankton.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/plankton.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/plankton.F90	(revision 10302)
@@ -36,13 +36,22 @@
                                    fdpn, fdpn2, fdzme, fdzme2,             &
                                    fdzmi, fdzmi2, fsdiss, fsin,            &
+                                   fdep1, fprn, fprd,                      &
+                                   fgmepd, fgmepn, fgmipn,                 &
                                    zphd, zphn, zpds, zzme, zzmi
-      USE dom_oce,           ONLY: tmask
+      USE dom_oce,           ONLY: e3t_0, e3t_n, gdepw_0, gdepw_n, tmask
+      USE par_kind,          ONLY: wp
       USE par_oce,           ONLY: jpim1, jpjm1
       USE phytoplankton_mod, ONLY: phytoplankton
       USE sms_medusa,        ONLY: jmpd, jmpn, jmzme, jmzmi,               &
+                                   ln_foam_medusa,                         &
+                                   pgrow_avg, ploss_avg, phyt_avg,         &
                                    xkphd, xkphn, xkzme, xkzmi,             &
                                    xmetapd, xmetapn, xmetazme, xmetazmi,   &
                                    xmpd, xmpn, xmzme, xmzmi, xsdiss
+      USE zdfmxl,            ONLY: hmld
       USE zooplankton_mod,   ONLY: zooplankton
+
+   !!* Substitution
+#  include "domzgr_substitute.h90"
 
       !! Level
@@ -50,4 +59,6 @@
 
       INTEGER :: ji, jj
+
+      REAL(wp) :: fq0
 
       !!-------------------------------------------------------------------
@@ -188,4 +199,39 @@
       ENDDO
 
+      IF ( ln_foam_medusa ) THEN
+         !! Mixed layer averages for ocean colour assimilation
+         !!
+         DO jj = 2,jpjm1
+            DO ji = 2,jpim1
+               IF (tmask(ji,jj,jk) == 1) THEN
+                  if (fdep1(ji,jj).le.hmld(ji,jj)) then
+                     !! this level is entirely in the mixed layer
+                     fq0 = 1.0
+                  elseif (fsdepw(ji,jj,jk).ge.hmld(ji,jj)) then
+                     !! this level is entirely below the mixed layer
+                     fq0 = 0.0
+                  else
+                     !! this level straddles the mixed layer
+                     fq0 = (hmld(ji,jj) - fsdepw(ji,jj,jk)) / fse3t(ji,jj,jk)
+                  endif
+                  !!
+                  pgrow_avg(ji,jj) = pgrow_avg(ji,jj) +                   &
+                                     (((fprn(ji,jj) * zphn(ji,jj)) +      &
+                                       (fprd(ji,jj) * zphd(ji,jj))  ) *   &
+                                      fse3t(ji,jj,jk) * fq0)
+                  ploss_avg(ji,jj) = ploss_avg(ji,jj) +                   &
+                                     ((fgmepd(ji,jj) + fdpd(ji,jj) +      &
+                                       fdpd2(ji,jj)                +      &
+                                       fgmepn(ji,jj) + fdpn(ji,jj) +      &
+                                       fdpn2(ji,jj)  + fgmipn(ji,jj) ) *  &
+                                      fse3t(ji,jj,jk) * fq0)
+                  phyt_avg(ji,jj)  = phyt_avg(ji,jj)  +                   &
+                                     ((zphn(ji,jj) + zphd(ji,jj)) *       &
+                                      fse3t(ji,jj,jk) * fq0)
+               ENDIF
+            ENDDO
+         ENDDO
+      ENDIF
+
    END SUBROUTINE plankton
 
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90	(revision 10302)
@@ -177,5 +177,12 @@
    INTEGER  ::  jdms_model   !: choice of DMS model passed to atmosphere
 !!                              1 = ANDR, 2 = SIMO, 3 = ARAN, 4 = HALL
-!!
+!! JPALM --19-12-2017 -- UM people need to tune the Anderson DMS scheme    
+   REAL(wp) ::  dmsmin       !: Anderson DMS scheme - DMS minimum value
+   REAL(wp) ::  dmscut       !: Anderson DMS scheme - DMS cutoff value 
+   REAL(wp) ::  dmsslp       !: Anderson DMS scheme - DMS slope 
+!! FOR UKESM   
+   REAL(wp) ::  scl_chl      !: scaling factor for tuned Chl passed to the UM 
+   INTEGER  ::  chl_out      !: select Chl field exported and scaled for UM:
+                             !: 1- Surface Chl ; 2- MLD Chl
 !!
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   remdmp   !: depth dependent damping coefficient of passive tracers 
@@ -205,4 +212,8 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: f2_ccd_arg  !: 2D aragonite CCD depth
 !!
+!! 2D fields of pCO2 and fCO2 for observation operator
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: f2_pco2w    !: 2D pCO2
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: f2_fco2w    !: 2D fCO2
+!!
 !! 2D fields of organic and inorganic material sedimented on the seafloor
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: zb_sed_n    !: 2D organic nitrogen   (before)
@@ -276,112 +287,21 @@
 #if defined key_roam
 !!----------------------------------------------------------------------
-!! Atmospheric pCO2 data (1859 to 2100 inclusive)
-!!----------------------------------------------------------------------
-!!
-   REAL(wp), DIMENSION(242)         ::   hist_pco2 !: pCO2
-
-# if defined key_rcp26
-      !! UKMO, run AJKKH + KAAEC, RCP 2.6, pCO2 time evolution
-      DATA hist_pco2 / 286.0230, 286.1730, 286.3230, 286.4480, 286.5730, &
-      & 286.7230, 286.8480, 286.9480, 287.0480, 287.1730, &
-      & 287.3230, 287.4730, 287.6480, 287.8480, 288.0730, &
-      & 288.3480, 288.6480, 288.9730, 289.3470, 289.7470, &
-      & 290.1730, 290.6470, 291.1470, 291.6220, 292.0720, &
-      & 292.5220, 292.9220, 293.2470, 293.5220, 293.7470, &
-      & 293.9470, 294.1220, 294.2720, 294.4220, 294.5470, &
-      & 294.6470, 294.7470, 294.8470, 294.9710, 295.1710, &
-      & 295.4460, 295.7470, 296.0720, 296.4210, 296.7710, &
-      & 297.1460, 297.5710, 298.0210, 298.4460, 298.8460, &
-      & 299.2460, 299.6450, 300.0210, 300.3710, 300.7200, &
-      & 301.0450, 301.3460, 301.6710, 302.0200, 302.3450, &
-      & 302.6450, 302.9700, 303.3450, 303.7200, 304.0700, &
-      & 304.4700, 304.9200, 305.3440, 305.7700, 306.2450, &
-      & 306.7190, 307.1700, 307.6440, 308.1190, 308.5440, &
-      & 308.9440, 309.3440, 309.6940, 309.9440, 310.1190, &
-      & 310.2440, 310.3190, 310.3190, 310.2440, 310.1440, &
-      & 310.0690, 310.0440, 310.0690, 310.1440, 310.2690, &
-      & 310.4440, 310.6940, 311.0430, 311.4440, 311.8690, &
-      & 312.3680, 312.9430, 313.5430, 314.1680, 314.7900, &
-      & 315.4430, 316.2150, 317.0170, 317.7370, 318.3400, &
-      & 318.8680, 319.5900, 320.5890, 321.5470, 322.5770, &
-      & 323.8440, 324.9260, 325.7960, 327.0810, 328.6180, &
-      & 329.6830, 330.5250, 331.6880, 333.2120, 334.7870, &
-      & 336.4640, 338.2990, 339.6660, 340.7310, 342.1360, &
-      & 343.7200, 345.2200, 346.7350, 348.5820, 350.6740, &
-      & 352.4230, 353.7910, 354.9530, 355.8210, 356.7130, &
-      & 358.0630, 359.7720, 361.3970, 363.0900, 365.2560, &
-      & 367.2810, 368.7980, 370.4000, 372.4550, 374.6920, &
-      & 376.7440, 378.7440, 380.7580, 382.7080, 384.7300, &
-      & 386.9310, 389.2150, 391.4910, 393.7710, 396.0460, &
-      & 398.3240, 400.6080, 402.8950, 405.1780, 407.4550, &
-      & 409.7260, 411.9930, 414.2500, 416.4410, 418.5280, &
-      & 420.5250, 422.4390, 424.2720, 426.0200, 427.6750, &
-      & 429.2360, 430.7050, 432.0850, 433.3580, 434.5140, &
-      & 435.5740, 436.5490, 437.4420, 438.2550, 438.9810, &
-      & 439.6110, 440.1430, 440.5770, 440.9450, 441.2660, &
-      & 441.5410, 441.7840, 442.0050, 442.2040, 442.3780, &
-      & 442.5210, 442.6200, 442.6720, 442.6810, 442.6540, &
-      & 442.5830, 442.4670, 442.3270, 442.1680, 441.9960, &
-      & 441.8060, 441.5930, 441.3440, 441.0540, 440.7230, &
-      & 440.3510, 439.9300, 439.4650, 438.9730, 438.4630, &
-      & 437.9400, 437.4020, 436.8400, 436.2640, 435.6850, &
-      & 435.1030, 434.5160, 433.9170, 433.3060, 432.7010, &
-      & 432.1110, 431.5380, 430.9810, 430.4320, 429.8860, &
-      & 429.3370, 428.7810, 428.2220, 427.6490, 427.0660, &
-      & 426.4890, 425.9270, 425.3840, 424.8610, 424.3540, &
-      & 423.8540, 423.3540, 422.8530, 422.3510, 421.8410, &
-      & 421.3250, 420.8190 /
-# else
-      !! UKMO, run AJKKH + KAAEF, RCP 8.5, pCO2 time evolution
-      DATA hist_pco2 / 286.0230, 286.1730, 286.3230, 286.4480, 286.5730, &
-      & 286.7230, 286.8480, 286.9480, 287.0480, 287.1730, &
-      & 287.3230, 287.4730, 287.6480, 287.8480, 288.0730, &
-      & 288.3480, 288.6480, 288.9730, 289.3470, 289.7470, &
-      & 290.1730, 290.6470, 291.1470, 291.6220, 292.0720, &
-      & 292.5220, 292.9220, 293.2470, 293.5220, 293.7470, &
-      & 293.9470, 294.1220, 294.2720, 294.4220, 294.5470, &
-      & 294.6470, 294.7470, 294.8470, 294.9710, 295.1710, &
-      & 295.4460, 295.7470, 296.0720, 296.4210, 296.7710, &
-      & 297.1460, 297.5710, 298.0210, 298.4460, 298.8460, &
-      & 299.2460, 299.6450, 300.0210, 300.3710, 300.7200, &
-      & 301.0450, 301.3460, 301.6710, 302.0200, 302.3450, &
-      & 302.6450, 302.9700, 303.3450, 303.7200, 304.0700, &
-      & 304.4700, 304.9200, 305.3440, 305.7700, 306.2450, &
-      & 306.7190, 307.1700, 307.6440, 308.1190, 308.5440, &
-      & 308.9440, 309.3440, 309.6940, 309.9440, 310.1190, &
-      & 310.2440, 310.3190, 310.3190, 310.2440, 310.1440, &
-      & 310.0690, 310.0440, 310.0690, 310.1440, 310.2690, &
-      & 310.4440, 310.6940, 311.0430, 311.4440, 311.8690, &
-      & 312.3680, 312.9430, 313.5430, 314.1680, 314.7900, &
-      & 315.4430, 316.2150, 317.0170, 317.7370, 318.3400, &
-      & 318.8680, 319.5900, 320.5890, 321.5470, 322.5770, &
-      & 323.8440, 324.9260, 325.7960, 327.0810, 328.6180, &
-      & 329.6830, 330.5250, 331.6880, 333.2120, 334.7870, &
-      & 336.4640, 338.2990, 339.6660, 340.7310, 342.1360, &
-      & 343.7200, 345.2200, 346.7350, 348.5820, 350.6740, &
-      & 352.4230, 353.7910, 354.9530, 355.8210, 356.7130, &
-      & 358.0630, 359.7720, 361.3970, 363.0900, 365.2560, &
-      & 367.2810, 368.7980, 370.4000, 372.4550, 374.6920, &
-      & 376.7440, 378.7440, 380.7580, 382.7080, 384.7300, &
-      & 386.9420, 389.2540, 391.5670, 393.9370, 396.3920, &
-      & 398.9320, 401.5550, 404.2550, 407.0220, 409.8530, &
-      & 412.7470, 415.7050, 418.7210, 421.7880, 424.9180, &
-      & 428.1200, 431.3970, 434.7470, 438.1650, 441.6410, &
-      & 445.1700, 448.7530, 452.3920, 456.0950, 459.8810, &
-      & 463.7680, 467.7660, 471.8750, 476.0960, 480.4210, &
-      & 484.8390, 489.3470, 493.9430, 498.6400, 503.4380, &
-      & 508.3410, 513.3630, 518.5160, 523.8050, 529.2290, &
-      & 534.7780, 540.4450, 546.2230, 552.1120, 558.1110, &
-      & 564.2110, 570.4130, 576.7390, 583.1990, 589.7980, &
-      & 596.5390, 603.4110, 610.4060, 617.4940, 624.6500, &
-      & 631.8800, 639.1750, 646.5360, 653.9800, 661.5230, &
-      & 669.1840, 676.9570, 684.8290, 692.7790, 700.7690, &
-      & 708.8050, 716.8870, 725.0020, 733.1770, 741.3900, &
-      & 749.6700, 758.0480, 766.5050, 775.0350, 783.6110, &
-      & 792.2200, 800.8740, 809.5680, 818.2760, 827.0090, &
-      & 835.8020, 844.6550, 853.5730, 862.5690, 871.6190, &
-      & 880.7020, 889.8240, 898.9590, 908.1270, 917.3080, &
-      & 926.4960, 935.7040 /
-# endif
+!! JPALM -- change hist_pco2 init
+!!----------------------------------------------------------------------
+!!
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:)   ::   hist_pco2 !: pCO2
+   INTEGER  :: co2_rec
+   REAL(wp) :: co2_yinit, co2_yend    !: First and Last year read in the xCO2.atm file
+   REAL(wp) :: xobs_xco2a             !: Observed atmospheric xCO2, from namelist
+#endif
+
+!!----------------------------------------------------------------------
+!! JPALM -- PI CO2 key
+!!----------------------------------------------------------------------
+!!
+#if defined key_axy_pi_co2
+   LOGICAL , PUBLIC ::   lk_pi_co2 = .TRUE.  !: PI xCO2 used
+#else
+   LOGICAL , PUBLIC ::   lk_pi_co2 = .FALSE. !: PI xCO2 unused
 #endif
 
@@ -434,4 +354,15 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: cmask       !: ???
 
+!!----------------------------------------------------------------------
+!! Parameters required for ocean colour assimilation
+!!----------------------------------------------------------------------
+!!
+   LOGICAL :: ln_foam_medusa                                 !: Flag to calculate and save diagnostics
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: pgrow_avg  !: Mixed layer average phytoplankton growth
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: ploss_avg  !: Mixed layer average phytoplankton loss
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: phyt_avg   !: Mixed layer average phytoplankton
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: mld_max    !: Maximum mixed layer depth
+!!
+
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
@@ -446,5 +377,5 @@
       !!----------------------------------------------------------------------
       USE lib_mpp , ONLY: ctl_warn
-      INTEGER ::   ierr(8)        ! Local variables
+      INTEGER ::   ierr(9)        ! Local variables
       !!----------------------------------------------------------------------
       ierr(:) = 0
@@ -456,4 +387,5 @@
       !* 2D and 3D fields of carbonate system parameters
       ALLOCATE( f2_ccd_cal(jpi,jpj)  , f2_ccd_arg(jpi,jpj)  ,       &
+                f2_pco2w(jpi,jpj)    , f2_fco2w(jpi,jpj)    ,       &
          &      f3_pH(jpi,jpj,jpk)   , f3_h2co3(jpi,jpj,jpk),       &
          &      f3_hco3(jpi,jpj,jpk) , f3_co3(jpi,jpj,jpk)  ,       &
@@ -504,4 +436,7 @@
          &      ffln(jpi,jpj,jpk)    , fflf(jpi,jpj,jpk)    ,       &
          &      ffls(jpi,jpj,jpk)    , cmask(jpi,jpj)       ,    STAT=ierr(8) ) 
+      !* Fields for ocean colour data assimilation
+      ALLOCATE( pgrow_avg(jpi,jpj)   , ploss_avg(jpi,jpj)   ,       &
+         &      phyt_avg(jpi,jpj)    , mld_max(jpi,jpj)     ,    STAT=ierr(9) )
 #endif
       !
